package WebFlow.tao_window;

import WebFlow.*;
import WebFlow.event.*;
import java.awt.*;
import java.io.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.net.*;
import java.util.*;
import org.omg.CORBA.*;

public class Client extends Frame{
  public ControlPanel controlPanel;//buttons
  public Panel headerPanel;
  public DisplayPanel dp;//display area
  private ORB orb;
  private org.omg.CORBA.Object obj;
  private Data_Storage s;
  private static tao_jdbc taoImpl;

   public static void main(String args[])
   {
      configReader config ;

      try
      {
         //  Create ORB
         Properties props = System.getProperties();
         props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
         props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
         System.setProperties(props);

         ORB orb = ORB.init(args, props);


         //  Connect to the master server

         if(args.length !=1) {
           System.out.println("Usage:");
           System.out.println("   WebFlow.JobService.Client url xml");
           System.out.println("     url - url to the master's IOR");
           System.exit(1);
         }
         String masterURL = args[0] ;

         String ref ;
         org.omg.CORBA.Object obj = null ;
         System.out.println(" masterURL : "+masterURL);

         ref = getIORFromURL(masterURL);
         System.out.println("REF: "+ref);

         obj = orb.string_to_object(ref);

         if(obj == null)
              throw new RuntimeException();
         WebFlowContext ws =  WebFlowContextHelper.narrow(obj);
         System.out.println("Clinet: got master "+ws);

         if(ws == null)
               throw new RuntimeException();

         System.out.println("attach event");
         org.omg.CORBA.Object p1 = ws.addNewModule( "tao_jdbc" );
         System.out.println("narrow");
		taoImpl = tao_jdbcHelper.narrow( p1 );
		new Client();
		}     
		catch(COMM_FAILURE ex) {
        System.out.println("Command_Error: "+ex);

        System.err.println(ex.getMessage());
        ex.printStackTrace();
        System.exit(1);
       }
  }//method

  static public String getIORFromURL(String url) {
   System.out.println("Slave WebFlow is getting IOR from url:"+url);
   String masterServerIOR ="";
   String thisLine = null ;

   // Open the URL for reading

   try{
        URL u = new URL(url);

        // now turn the URL into a DataInputStream

        try{
         DataInputStream theHTML = new DataInputStream(u.openStream());

          while((thisLine = theHTML.readLine()) != null){
             masterServerIOR += thisLine ;
          }
        }
        catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e);
        }
     }
     catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e);
     }
    return masterServerIOR ;
  }


  public Client() {
    super( "JDBC CORBA" );
    setSize( 600, 450 );
    // set background color to lightGray, add HeaderPanel,
    //DisplayPanel and controlPanel components
    setBackground(Color.pink);
    headerPanel = new Panel();
    headerPanel.setFont(new Font("Helvetica", Font.PLAIN, 24));
    headerPanel.add(new Label("CORBA Database Connectivity"));
    add("North", headerPanel);
    add("Center", dp = new DisplayPanel());//display area
    //buttons!
    add("South",  controlPanel = new ControlPanel(this));
    setVisible( true );
    show();
  }

  public void search( Data_Storage temp_storage ){
    System.out.println( "Looking for " + temp_storage.job );
    dp.showResult( taoImpl.findRecord( temp_storage ) );
    System.out.println("got back from db." );
  }


  public void adddate( Data_Storage temp_storage ){
    if( temp_storage.job.equals( "null" ) )
        dp.showerr( 1 );
    else{
        taoImpl.makeRecord( temp_storage );
        dp.showOk( 1 );
    }
  }

   public void delete_date( Data_Storage temp_storage ) {
    if( temp_storage.job.equals( "null" ))
        dp.showerr( 2 );
    else {
        taoImpl.deleteRecord( temp_storage );
        dp.showOk( 2 );
    }
   }

  }

/** The ControlPanel with two panels, connectionPanel with insert, delete,
    update, search, clear, and close buttons; searchPanel with labels and
    textfields which provide to client type in.
 API:
   ControlPanel( Client );
   actionPerformed( ActionEvent );
 */
class ControlPanel extends Panel implements ActionListener {

  private Client parent;
  private TextField job, month, day, year;
  private Label lbl;
  private Panel searchPanel;
  private Panel connectionPanel;
  private Button searchPro, insert, delete;
  private Data_Storage s;

  /**Input:Client obj.
     Output:void
     Function:initialize the screen.
  **/
  public ControlPanel( Client clt ) {
    parent = clt;
    setLayout(new BorderLayout());
    setFont(new Font("Helvitica", Font.PLAIN, 14));
    searchPanel = new Panel();
    searchPanel.setLayout( new GridLayout( 4, 2 ) );
    connectionPanel = new Panel();

    delete = new Button( "Delete Process" );
    insert = new Button("Add Process");
    searchPro = new Button("Search Process");
    delete.addActionListener( this );
    insert.addActionListener(this);
    searchPro.addActionListener(this);
    connectionPanel.add( insert );
    connectionPanel.add( searchPro );
    connectionPanel.add( delete );
    searchPanel.add( new Label( "Job Name" ) );
    searchPanel.add( job = new TextField(20));
	searchPanel.add( new Label( "Year" ) );
    searchPanel.add( year = new TextField(20));
	searchPanel.add( new Label( "Month" ) );
    searchPanel.add( month = new TextField(20));
	searchPanel.add( new Label( "Day" ) );
    searchPanel.add( day = new TextField(20));
    add("North",connectionPanel);
    add("South",searchPanel);
  }

  /**Input:ActionEvent obj.
     Output:void
     Function:waiting something happen.
  **/
  public void actionPerformed(ActionEvent event) {
    String buttonLabel = event.getActionCommand();

    if(buttonLabel.equals("Search Process")) {
    try {
        System.out.println("search for job: " + job.getText() );
        s = new Data_Storage( "null", "null", "null", "null", "null", "null" );
    //look for the process information.
        if( !(job.getText().equals( "" ) || job.getText().equals( null )) )
            s.job = job.getText();
        if( !( year.getText().equals( "" )) )
            s.year = year.getText();
		if( !( month.getText().equals( "" ) ) )
			s.month = month.getText();
		if( !( day.getText().equals( "" )) )
			s.day = day.getText();
         parent.search( s );
    }
    catch (Exception ex) {
      }
    }//if search

    if(buttonLabel.equals("Add Process")) {
      try {
       System.out.println("Add Process" + job.getText() );
       s = new Data_Storage( "null", "null", "null", "null", "null", "null");
    //look for the process information.
        if( !(job.getText().equals( "" )) )
            s.job = job.getText();
		java.util.Date date = new java.util.Date();
		s.year = String.valueOf( date.getYear());
		s.month =  String.valueOf( date.getMonth() + 1 );
		s.day =  String.valueOf( date.getDate());
		s.hours =  String.valueOf( date.getHours());
		s.minutes =  String.valueOf( date.getMinutes());
        parent.adddate( s );
        }
    catch (Exception ex) {
      }
    }//if add


   if(buttonLabel.equals("Delete Process")) {
      try {
        System.out.println("Delete Process " + job.getText() );
        s = new Data_Storage( "null", "null", "null", "null", "null", "null" );
    //look for the process information.
        if( !(job.getText().equals( "" )) )
            s.job = job.getText();
        parent.delete_date( s );
        }
    catch (Exception ex) {
      }
    }//if delete
  }//method

}//class

class DisplayPanel extends Panel {
  TextArea resultArea;
  String nodata = "Sorry! There is no such process.";
  String namedata = "Sorry! You should type in job name.";

  /**Input:void.
     Output:void,
     Function:initialize the display area.
  **/
  public DisplayPanel() {
    setLayout(new BorderLayout(10,10));
    resultArea = new TextArea(15,60);
    resultArea.setBackground(Color.white);
	setForeground(Color.black);
	String temp = "1.When you add a process in database," + "\n" + "  Just type in Job name.The time add auto." + "\n" + "2.When you look for a process," + "\n" + "  Please type in the Year, Month, and Day;" + "\n" + " or just Job name.";
    resultArea.setFont( new Font("Times-Roman",Font.PLAIN,18));
	resultArea.setText( temp );
    add("Center",resultArea);
  }


  public void showResult( Data_Storage[] data ){
    resultArea.setFont( new Font("Times-Roman",Font.PLAIN,16));
    setForeground(Color.black);
    int i = 0;
    StringBuffer _stringbuffer = new StringBuffer();
    for( i = 0; i < data.length; i++ ){
        Data_Storage temp;
        temp = data[ i ];
        _stringbuffer.append( "Job: " + temp.job +"\n" );
        _stringbuffer.append( "Year: " + temp.year + "\n" );
        _stringbuffer.append( "Month: " + temp.month + "\n" );
        _stringbuffer.append( "Day: " + temp.day + "\n" );
        _stringbuffer.append( "Hour: " + temp.hours + "\n" );
        _stringbuffer.append( "Minute: " + temp.minutes + "\n" );
    }
    if( i == 0 ){
      resultArea.setFont( new Font("Times-Roman",Font.PLAIN,18));
      setForeground(Color.red);
      resultArea.setText("\n\n\n " + nodata);
    }
    else
        resultArea.setText( _stringbuffer.toString() );
  }//method

  public void showerr( int a ) {
    if( a == 1 ){//shoe the error of time be forgotten.
      resultArea.setFont( new Font("Times-Roman",Font.PLAIN,18));
      setForeground(Color.red);
      resultArea.setText("\n\n\n " +namedata );
    }
    else{
      resultArea.setFont( new Font("Times-Roman",Font.PLAIN,18));
      setForeground(Color.red);
      resultArea.setText("\n\n\n " + namedata );
    }
  }//method

  public void showOk( int a ) {
    resultArea.setFont( new Font("Times-Roman",Font.PLAIN,16));
    setForeground(Color.black);
    if( a == 1 )
        resultArea.setText( "Inserting is successful." );
    else
        resultArea.setText( "Deleting is successful." );
  }//method
}//class



